﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Stormtrooper
{
    internal class DrawningMilitary : Drawning
    {
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес самолёта</param>
        /// <param name="bodyColor">Цвет кузова</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="bodyKit">Признак наличия обвеса</param>
        /// <param name="rocket">Признак наличия антикрыла</param>
        /// <param name="sportLine">Признак наличия гоночной полосы</param>
        public void SetDopColor(Color color)
        {
            ((EntityMilitaryStormtrooper)Storm).DopColor = color;
        }
        public DrawningMilitary(int speed, float weight, Color bodyColor, Color dopColor, bool bodyKit, bool rocket, bool sportLine) :
        base(speed, weight, bodyColor, 135, 100)
        {
            Storm = new EntityMilitaryStormtrooper(speed, weight, bodyColor, dopColor, bodyKit, rocket, sportLine);
        }

        public override void DrawTransport(Graphics g)
        {
            if (Storm is not EntityMilitaryStormtrooper militaryTrop)
            {
                return;
            }
            Pen pen = new(Color.Black);
            Brush dopBrush = new SolidBrush(militaryTrop.DopColor);

            if (militaryTrop.BodyKit)
            {

                g.DrawEllipse(pen, _startPosX - 2, _startPosY - 70, 5, 20);
                g.DrawEllipse(pen, _startPosX - 2, _startPosY - 50, 5, 20);

                g.FillEllipse(dopBrush, _startPosX - 2, _startPosY - 70, 5, 20);
                g.FillEllipse(dopBrush, _startPosX - 2, _startPosY - 50, 5, 20);
            }

            _startPosX += 2;
            base.DrawTransport(g);
            _startPosX -= 2;

            if (militaryTrop.Rocket)
            {
                g.FillRectangle(dopBrush, _startPosX + 50, _startPosY - 70, 40, 3);
                g.FillRectangle(dopBrush, _startPosX + 50, _startPosY - 90, 40, 3);
                g.FillRectangle(dopBrush, _startPosX + 50, _startPosY - 30, 40, 3);
                g.FillRectangle(dopBrush, _startPosX + 50, _startPosY - 10, 40, 3);
            }

            if (militaryTrop.SportLine)
            {
                g.FillRectangle(dopBrush, _startPosX + 30, _startPosY - 60, 8, 20);
                g.FillRectangle(dopBrush, _startPosX + 100, _startPosY - 60, 8, 20);
            }

        }
    }
}
