﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Stormtrooper
{
    internal class DrawningObjectStorm : IDrawningObject
    {
        private Drawning _storm = null;
        public DrawningObjectStorm(Drawning storm)
        {
            _storm = storm;
        }
        public float Step => _storm?.Storm?.Step ?? 0;
        public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
        {
            return _storm?.GetCurrentPosition() ?? default;
        }
        public void MoveObject(Direction direction)
        {
            _storm?.MoveTransport(direction);
        }
        public void SetObject(int x, int y, int width, int height)
        {
            _storm.SetPosition(x, y, width, height);
        }
        void IDrawningObject.DrawningObject(Graphics g)
        {
            if (_storm is DrawningMilitary)
                ((DrawningMilitary)_storm).DrawTransport(g);
            _storm.DrawTransport(g);
        }
        public string GetInfo() => _storm?.GetDataForSave();
        public static IDrawningObject Create(string data) => new DrawningObjectStorm(data.CreateDrawningStormtrooper());

    }
}
