﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Stormtrooper
{
    /// <summary>
    /// Расширение для класса DrawningStormtrooper
    /// </summary>
    internal static class ExtentionStormtrooper
    {
        /// <summary>
        /// Разделитель для записи информации по объекту в файл
        /// </summary>
        private static readonly char _separatorForObject = ':';
        /// <summary>
        /// Создание объекта из строки
        /// </summary>
        /// <param name="info"></param>
        /// <returns></returns>
        public static Drawning CreateDrawningStormtrooper(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new Drawning(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 7)
            {
                return new DrawningMilitary(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
               Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]));
            }
            return null;
        }
        /// <summary>
        /// Получение данных для сохранения в файл
        /// </summary>
        /// <param name="drawningStormtrooper"></param>
        /// <returns></returns>
        public static string GetDataForSave(this Drawning drawningStormtrooper)
        {
            var stormtrooper = drawningStormtrooper.Storm;
            var str = $"{stormtrooper.Speed}{_separatorForObject}{stormtrooper.Weight}{_separatorForObject}{stormtrooper.BodyColor.Name}";
            if (stormtrooper is not EntityMilitaryStormtrooper militaryStormtrooper)
            {
                return str;
            }
            return
           $"{str}{_separatorForObject}{militaryStormtrooper.DopColor.Name}{_separatorForObject}{militaryStormtrooper .BodyKit}{_separatorForObject}{militaryStormtrooper.Rocket}{_separatorForObject}{militaryStormtrooper.SportLine}";
        }
    }

}
