namespace Stormtrooper
{
    public partial class FormStormtrooper : Form
    {
        private Drawning _storm;

        /// <summary>
        ///  
        /// </summary>
        public Drawning SelectedStormtrooper { get; private set; }

        public FormStormtrooper()
        {
            InitializeComponent();
        }
        /// <summary>
        ///   
        /// </summary>
        private void Draw()
        {
            Bitmap bmp = new(pictureBoxStormtrooper.Width, pictureBoxStormtrooper.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _storm?.DrawTransport(gr);
            pictureBoxStormtrooper.Image = bmp;
        }

        /// <summary>
        ///   
        /// </summary>
        private void SetData()
        {
            Random rnd = new();
            _storm.SetPosition(rnd.Next(0, 150), rnd.Next(0, 300), pictureBoxStormtrooper.Width, pictureBoxStormtrooper.Height);
            toolStripStatusLabelSpeed.Text = $": {_storm.Storm.Speed}";
            toolStripStatusLabelWeight.Text = $": {_storm.Storm.Weight}";
            toolStripStatusLabelColor.Text = $": {_storm.Storm.BodyColor.Name}";
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _storm = new Drawning(rnd.Next(100, 300), rnd.Next(1000, 2000), color);
            SetData();
            Draw();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _storm?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _storm?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _storm?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _storm?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PictureBoxStormtrooper_Resize(object sender, EventArgs e)
        {
            _storm?.ChangeBorders(pictureBoxStormtrooper.Width, pictureBoxStormtrooper.Height);
            Draw();
        }

        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreateModif_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            _storm = new DrawningMilitary(rnd.Next(100, 300), rnd.Next(1000, 2000),
                Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)),
                Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)),
                 Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }

        private void ButtonSelectStorm_Click(object sender, EventArgs e)
        {
            SelectedStormtrooper = _storm;
            DialogResult = DialogResult.OK;
        }
    }
}